.alias SP 15	; stack pointer
.alias BP 14	; function frame base pointer
.alias SI 13	; source address
.alias DI 12	; destination address
.alias CX 11	; counter

.text

.global chebyshev; proc 20 0
chebyshev:
	.alias chebyshev.RV #BP,8

	.alias chebyshev.x.0C #BP,12
	.alias chebyshev.f.4C #BP,16
	.alias chebyshev.n.8C #BP,20

	.alias chebyshev.x.0A #BP,12
	.alias chebyshev.f.4A #BP,16
	.alias chebyshev.n.8A #BP,20

	.alias chebyshev.b1.4RD #BP,-4
	.alias chebyshev.i.8RD #BP,-8
	.alias chebyshev.b2.12RD #BP,-12
	.alias chebyshev.b0.16RD #BP,-16
	.alias chebyshev.x2.20RD #BP,-20

	jmp	chebyshev.P0
	getl	#SP
	getl	#BP
	subl	@2, 4
	wrl	@2, @1
	setl	#BP, @2
	subl	@5, 28
	setl	#SP, @1
	complete
; line 255
; line 259

; BLOCK:TREE 0:0
; 0	ADDRLP4 chebyshev.x2.20RD
; 1	CNSTF4 0x40000000
; 0	ADDRFP4 chebyshev.x.0A
; 2	INDIRF4
; 3	MULF4
; 4	ASGNF4
; line 260

; BLOCK:TREE 0:1
; 0	ADDRLP4 chebyshev.b2.12RD
; 1	CNSTF4 0x3f800000
; 2	ASGNF4
; line 261

chebyshev.P0:
;                               jmp	chebyshev.P1
	getl	0x40000000		; 1: 0x40000000 -> l 2.000000
	rdl	chebyshev.x.0A		; 2: chebyshev.x.0A -> BP[12]
	mulf	@2, @1			; 3: @2 -> 1, @1 -> 2
	wrl	@1, chebyshev.x2.20RD	; 4: @1 -> 3, chebyshev.x2.20RD -> BP[-20]
	getl	0x3f800000		; 1: 0x3f800000 -> l 1.000000
	wrl	@1, chebyshev.b2.12RD	; 2: @1 -> 1, chebyshev.b2.12RD -> BP[-12]

;                     chebyshev.P1:
;                               jmp	chebyshev.P2
	rdl	chebyshev.f.4A		; 1: chebyshev.f.4A -> BP[16]
	addl	@1, 0x00000004		; 2: @1 -> 1, 0x00000004 -> sl 4
;                             rdl	chebyshev.x2.20RD	; 3: chebyshev.x2.20RD -> BP[-20]
	rdl	@1			; 4: @2 -> 2
	addf	@7, @1			; 5: @2 -> 3, @1 -> 4
	wrl	@1, chebyshev.b1.4RD	; 6: @1 -> 5, chebyshev.b1.4RD -> BP[-4]
;                     chebyshev.P2:
	getsl	0x00000002		; 1: 0x00000002 -> sl 2
	wrsl	@1, chebyshev.i.8RD	; 2: @1 -> 1, chebyshev.i.8RD -> BP[-8]
;                               jmp	chebyshev.56L		; 1: chebyshev.56L -> GA
;                               rdsl	chebyshev.i.8RD		; 1: chebyshev.i.8RD -> BP[-8]
	rdsl	chebyshev.n.8A		; 2: chebyshev.n.8A -> BP[20]
	subsl	@3, @1			; 3: @2 -> 1, @1 -> 2
	jl	@1, chebyshev.53L	; 4: @1 -> 3
	jge	@2, chebyshev.P8	; 5: @2 -> 3
	complete

chebyshev.53L:; fpc: 0:0 1:0 2:0 3:0

;                     chebyshev.P3:
;                               jmp	chebyshev.P4
	rdsl	chebyshev.i.8RD		; 1: chebyshev.i.8RD -> BP[-8]
	rdl	chebyshev.x2.20RD	; 2: chebyshev.x2.20RD -> BP[-20]
	rdl	chebyshev.b1.4RD	; 3: chebyshev.b1.4RD -> BP[-4]
	sllsl	@3, 0x00000002		; 4: @3 -> 1, 0x00000002 -> sl 2
	rdl	chebyshev.f.4A		; 5: chebyshev.f.4A -> BP[16]
	mulf	@4, @3			; 6: @4 -> 2, @3 -> 3
	rdl	chebyshev.b2.12RD	; 7: chebyshev.b2.12RD -> BP[-12]
	addl	@4, @3			; 8: @4 -> 4, @3 -> 5
	subf	@3, @2			; 9: @3 -> 6, @2 -> 7
	rdl	@2			; 10: @2 -> 8
	addf	@2, @1			; 11: @2 -> 9, @1 -> 10
	wrl	@1, chebyshev.b0.16RD	; 12: @1 -> 11, chebyshev.b0.16RD -> BP[-16]

;                     chebyshev.P4:
;                               jmp	chebyshev.P5
;                               rdl	chebyshev.b1.4RD	; 1: chebyshev.b1.4RD -> BP[-4]
	wrl	@10, chebyshev.b2.12RD	; 2: @1 -> 1, chebyshev.b2.12RD -> BP[-12]

;                     chebyshev.P5:
;                               jmp	chebyshev.P6
;                               rdl	chebyshev.b0.16RD	; 1: chebyshev.b0.16RD -> BP[-16]
	wrl	@3, chebyshev.b1.4RD	; 2: @1 -> 1, chebyshev.b1.4RD -> BP[-4]

;                     chebyshev.54L:; fpc: 0:0 1:0 2:0 3:0

;                     chebyshev.P6:
;                               jmp	chebyshev.P7
;                               rdsl	chebyshev.i.8RD		; 1: chebyshev.i.8RD -> BP[-8]
	addsl	@14, 0x00000001		; 2: @1 -> 1, 0x00000001 -> sl 1
	wrsl	@1, chebyshev.i.8RD	; 3: @1 -> 2, chebyshev.i.8RD -> BP[-8]

;                     chebyshev.56L:; fpc: 0:0 1:0 2:0 3:0

;                     chebyshev.P7:
;                               rdsl	chebyshev.i.8RD		; 1: chebyshev.i.8RD -> BP[-8]
	rdsl	chebyshev.n.8A		; 2: chebyshev.n.8A -> BP[20]
	subsl	@3, @1			; 3: @2 -> 1, @1 -> 2
	jl	@1, chebyshev.53L	; 4: @1 -> 3
	jge	@2, chebyshev.P8	; 5: @2 -> 3
	complete
; fpc: 0:0 1:0 2:0 3:0

; BLOCK:TREE 11:0
; 0	ADDRFP4 chebyshev.x.0A
; 4	INDIRF4
; 0	ADDRLP4 chebyshev.b1.4RD
; 5	INDIRF4
; 7	MULF4
; 0	ADDRLP4 chebyshev.b2.12RD
; 8	INDIRF4
; 11	SUBF4
; 9	CNSTF4 0x3f000000
; 0	ADDRFP4 chebyshev.n.8A
; 1	INDIRI4
; 0	CNSTI4 0x00000002
; 2	LSHI4
; 0	ADDRFP4 chebyshev.f.4A
; 3	INDIRP4
; 6	ADDP4
; 10	INDIRF4
; 12	MULF4
; 13	ADDF4
; 14	RETF4

chebyshev.P8:
	jmp	chebyshev.PF
	rdsl	chebyshev.n.8A		; 1: chebyshev.n.8A -> BP[20]
	sllsl	@1, 0x00000002		; 2: @1 -> 1, 0x00000002 -> sl 2
	rdl	chebyshev.f.4A		; 3: chebyshev.f.4A -> BP[16]
	rdl	chebyshev.x.0A		; 4: chebyshev.x.0A -> BP[12]
	rdl	chebyshev.b1.4RD	; 5: chebyshev.b1.4RD -> BP[-4]
	addl	@4, @3			; 6: @4 -> 2, @3 -> 3
	mulf	@3, @2			; 7: @3 -> 4, @2 -> 5
	rdl	chebyshev.b2.12RD	; 8: chebyshev.b2.12RD -> BP[-12]
	getl	0x3f000000		; 9: 0x3f000000 -> l 0.500000
	rdl	@4			; 10: @4 -> 6
	subf	@4, @3			; 11: @4 -> 7, @3 -> 8
	mulf	@3, @2			; 12: @3 -> 9, @2 -> 10
	addf	@2, @1			; 13: @2 -> 11, @1 -> 12
	wrl	@1, chebyshev.RV	; 14: @1 -> 13
	complete
; fpc: 0:1 1:0 2:2 3:1

; BLOCK:TREE 12:0
; 1	LABELV chebyshev.52L

chebyshev.52L:; fpc: 0:0 1:0 2:0 3:0

chebyshev.PF:
	rdl	#BP, 4
	jmp	@1
	getl	#BP
	rdl	#BP, 0
	addl	@2, 4
	setl	#BP, @2
	setl	#SP, @2
	wrl	  @0,0x7FFFC
	complete
; end proc chebyshev 20 0
