/*
   ITU-T G.729 Annex C - Reference C code for floating point
                         implementation of G.729 Annex A
                         Version 1.01 of 15.September.98
*/

/*
----------------------------------------------------------------------
                    COPYRIGHT NOTICE
----------------------------------------------------------------------
   ITU-T G.729 Annex C ANSI C source code
   Copyright (C) 1998, AT&T, France Telecom, NTT, University of
   Sherbrooke.  All rights reserved.

----------------------------------------------------------------------
*/

/*
 File : CODERA.C
 Used for the floating point version of G.729A only
 (not for G.729 main body)
*/

/*-------------------------------------------------------------------*
 * Main program of the ITU-T G.729A  8 kbit/s encoder.               *
 *                                                                   *
 *    Usage : coder speech_file  bitstream_file                      *
 *-------------------------------------------------------------------*/

#include "multiclet.h"
#include "TYPEDEF.h"
#include "ld8a.h"
#include "stdint.h"

  extern FLOAT Dn[L_SUBFR];
  extern FLOAT rr[DIM_RR];
  extern FLOAT past_qua_en[4];

void coder_init(){   
   /*-------------------------------------------------*
   * Initialization of the coder.                    *
   *-------------------------------------------------*/
   int i;
   init_pre_process();
   init_coder_ld8a();           /* Initialize the coder             */
   for(i=0;i<L_SUBFR;i++){
       Dn[i]=0;
   }
   for(i=0;i<DIM_RR;i++){
       rr[i]=0;
   }
   past_qua_en[0]=(F)-14.0;
   past_qua_en[1]=(F)-14.0;
   past_qua_en[2]=(F)-14.0;
   past_qua_en[3]=(F)-14.0;
}

   extern FLOAT *new_speech;           /* Pointer to new speech data   */
   int prm[PRM_SIZE];           /* Transmitted parameters        */
#ifndef R1_o   
void coder_main(int16_t * sp16,uint16_t * serial)
{

   int  i;   

   /*-------------------------------------------------------------------------*
    * Loop for every analysis/transmission frame.                             *
    * -New L_FRAME data are read. (L_FRAME = number of speech data per frame) *
    * -Conversion of the speech data from 16 bit integer to real              *
    * -Call cod_ld8a to encode the speech.                                    *
    * -The compressed serial output stream is written to a file.              *
    * -The synthesis speech is written to a file                              *
    *-------------------------------------------------------------------------*
    */

      for (i = 0; i < L_FRAME; i++){
          new_speech[i] = (FLOAT) sp16[i];	
      }

      pre_process( new_speech, L_FRAME);

      coder_ld8a(prm);
      
      serial[0]=prm[0]+(prm[2]<<8);
      serial[1]=prm[1]+(prm[3]<<10)+(prm[7]<<11);
      serial[2]=prm[4]+((prm[5]&0x7)<<13);
      serial[3]=prm[8]+((prm[9]&0x7)<<13);
      serial[4]=prm[6]+(prm[10]<<7)+((prm[5]&0x8)<<11)+((prm[9]&0x8)<<12);

} /* end of main() */
#endif
