#include <R1_ccf.h>
#include <gpio.h>
#include <adc.h>
#include <dac.h>
#include <tim.h>
#include <irq.h>

#define IRQ_VECTOR_GPTIM0 29
#define IRQ_VECTOR_ADC0 16


void interrupt_GPTIM0();
void interrupt_ADC0();


void main(){
    /*Устанавливаем тактовую частоту 80 МГц*/
    mc_set_pll(0x3, 0x6, 0xb, 1);
   
    /*Устанавливаем обработчики прерывания для таймера 0 и АЦП*/ 
    set_irq_vector(interrupt_GPTIM0, IRQ_VECTOR_GPTIM0);
    set_irq_vector(interrupt_ADC0, IRQ_VECTOR_ADC0);

	/*Настраиваем таймер 0*/
	TIM0->PSCPER = 0x4;
	TIM0->CNT0 = 0x4B0;
    
    /*Настраиваем АЦП и ЦАП*/    
    ADC0->CR = 0x60000;
    ADC0->CH0 = 0x11200000;
    DAC0->CR = 0;
    DAC1->CR = 0;      
    
    /*Включаем прерывания от АЦП и таймера 0*/
    asm_setl_MSKR((1<<29)|(1<<16));
    
	while(1);
}

void interrupt_GPTIM0(){
	unsigned dac = (((ADC0->CH0)&0xFFFF));
	if((dac&0x8000)!=0){
		dac = (((~dac)+1)&0xFFFF);
	}
	dac>>=4;
	DAC0->DATA = dac;
	DAC1->DATA = dac;
}

void interrupt_ADC0(){
	 TIM0->CR0 = 0xD;
}




